org.apache.bcel.classfile

## Class Unknown

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.Unknown

- All Implemented Interfaces:
    Cloneable, Node

      public final class Unknown
      extends Attribute

  This class represents a reference to an unknown (i.e., application-specific) attribute of a class. It is instantiated from the `Attribute.readAttribute(java.io.DataInput, ConstantPool)` method. Applications that need to read in application-specific attributes should create an `UnknownAttributeReader` implementation and attach it via `Attribute.addAttributeReader(String, UnknownAttributeReader)`.
  Version:
    $Id: Unknown.java 1806200 2017-08-25 16:33:06Z ggregory $
  See Also:
    `Attribute`, `UnknownAttributeReader`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Unknown(int name_index, int length, byte[] bytes, ConstantPool constant_pool)` Create a non-standard attribute.
    `Unknown(Unknown c)` Initialize from another object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool _constant_pool)`
    `void` | `dump(DataOutputStream file)` Dump unknown bytes to file stream.
    `byte[]` | `getBytes()`
    `String` | `getName()`
    `void` | `setBytes(byte[] bytes)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getNameIndex, getTag, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Unknown

          public Unknown(Unknown c)

      Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.

    - #### Unknown

          public Unknown(int name_index,
                         int length,
                         byte[] bytes,
                         ConstantPool constant_pool)

      Create a non-standard attribute.
      Parameters:
        `name_index` - Index in constant pool
        `length` - Content length in bytes
        `bytes` - Attribute contents
        `constant_pool` - Array of constants

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### dump

          public final void dump(DataOutputStream file)
                          throws IOException

      Dump unknown bytes to file stream.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException`

    - #### getBytes

          public final byte[] getBytes()

      Returns:
        data bytes.

    - #### getName

          public final String getName()

      Overrides:
        `getName` in class `Attribute`
      Returns:
        name of attribute.

    - #### setBytes

          public final void setBytes(byte[] bytes)

      Parameters:
        `bytes` - the bytes to set

    - #### toString

          public final String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation.

    - #### copy

          public Attribute copy(ConstantPool _constant_pool)

      Specified by:
        `copy` in class `Attribute`
      Returns:
        deep copy of this attribute

Copyright © 2004–2019 The Apache Software Foundation. All rights reserved.